
@font-face {
  font-family: xmas1; /* set name */
  src: url(PlayfulChristmas.otf); /* url of the font */
}
@font-face {
  font-family: xmas2; /* set name */
  src: url(MerryChristmasFlake.ttf); /* url of the font */
}
@font-face {
  font-family: xmas3; /* set name */
  src: url(MerryChristmasStar.ttf); /* url of the font */
}
@font-face {
  font-family: xmas4; /* set name */
  src: url(PWHappyChristmas.ttf); /* url of the font */
}

body {
    margin: 0;
    padding: 0;
    background-color: white;
    display: grid;
    grid-template-columns: 15% 15% 10px auto 15%;
    grid-template-rows: 0 auto 30px auto 10px 100px;
    grid-template-areas:
            '.  .       .       .       .   '
            '   header  header  header  header  header '
            '.  .       .       .       .   '
            '.  section section section .   '
            '.  .       .       .       .   '
            '.  footer  footer  footer  .   ';
    font-family: "Roboto", sans-serif;
    font-weight: normal;
    font-size: 80%;
}

    h1, h2, h3, h4 {
        padding: 0;
        margin: 0;
    }
    
    h2 {
    	margin-top: 0.7em;
    }

.compete-please {
	padding: 0 1em;
    margin-top: 2em;
}

.compete-please strong {
    color: #ff75ba;
}

header {
    grid-area: header;
    padding: 10px 15%;
    position: relative;
    background: rgb(2,0,36);
    background: hsla(226, 100%, 50%, 1);

    background: linear-gradient(0deg, hsla(248, 100%, 25%, 1) 23%, hsla(213, 100%, 51%, 1) 100%);
    background: -moz-linear-gradient(0deg, hsla(248, 100%, 25%, 1) 23%, hsla(213, 100%, 51%, 1) 100%);
    background: -webkit-linear-gradient(0deg, hsla(248, 100%, 25%, 1) 23%, hsla(213, 100%, 51%, 1) 100%);
    filter: progid: DXImageTransform.Microsoft.gradient( startColorstr="#11007E", endColorstr="#0374FF", GradientType=1 );

    background: #5452bf;
    background: linear-gradient(90deg, rgba(84, 82, 191, 1) 0%, rgba(187, 92, 198, 1) 33%, rgba(199, 102, 87, 1) 66%, rgba(252, 213, 56, 1) 100%);

    background: #3bbbdb;
    background: linear-gradient(90deg,rgba(59, 187, 219, 1) 0%, rgba(15, 0, 0, 1) 79%);

    background: #000000;
    background: linear-gradient(90deg, rgba(0, 0, 0, 1) 20%, rgba(0, 132, 255, 1) 68%, rgba(0, 187, 255, 1) 100%);
}

    header h1, header h1 a {
        display: block;
        padding: 0;
        margin: 0;
        font-weight: 100;
        text-decoration: none;
        color: white;
        /* font-family: xmas4; */
        font-family: "Roboto", sans-serif;
        font-size: 1.8em;
    }

    header p {
        display: block;
        padding: 0;
        margin: 0;
        color: lightgrey;
    }

    #logout-form button {
        border-color: red;
    }

    #header-right-flex button {
        display: flex;
        align-items: center;
        justify-content: flex-end;
        padding: 3px 8px;
        margin: 0 10px;
    }

    #header-right-flex a {
        text-decoration: none;
    }

    #header-message {
        background-color: orange;
        width: 100vw;
        text-align: center;
        position: fixed;
        top: 0;
        z-index: 100;
    }

    #header-right-flex {
        display: flex;
        right: 15%;
        top: 0;
        height: 100%;
        position: absolute;
        align-items: center;
        justify-content: flex-end;
    }

    #cookbook-link {
        border: 3px solid palegreen;
    }

section {
    grid-area: section;
}

    #login-section {
        position: absolute;
        width: 100vw;
        height: 100vh;
    }

    section h1 {
        color: #f44708;
        text-align: left;
    }

    section h2 {
        color: #00a6fb;
        font-size: 1.2em;
    }

    section h3 {
        color: #688e26;
        border-bottom-style: dashed;
    }

    section h4 {
        color: #faa613;
    }

    section p, section li {
        font-weight: normal;
        font-size: 0.9em;
        font-family: "Roboto", sans-serif;
        text-align: justify;
        line-height: 1.8em;
    }

    section ul {
        padding-left: 20px;
    }

    section b {
        font-weight: bold;
    }

    section strong {
        color: #f44708;
    }
    
    #test-protocol-wrapper{
        margin: 5px;
    	/*border: 1px solid rgba(0,0,255,0.1);*/
    	width: calc(100% - 10px);
    	display: flex;
    	flex-direction: column;
    }

    #test-protocol-wrapper .testResult{
    	width: calc(100% - 20px);
    	margin: 5px;
    	padding: 5px;
    }
    
    .correctTestResult {
    	background-color: palegreen;
    }
    
    .errorTestResult {
    	background-color: orange;
    }
    
    .testcase-in-expected-message {
    	color: rgb(128, 128, 128);
    	font-style: italic;
    }
    
    .warning-message {
    	background-color: #ffe7b3;
    	width: calc(100% - 20px);
    	padding: 5px;
    	margin: 5px;
    }

aside {
    grid-area: aside;
}

    aside h1 {
        color: #f44708;
    }

    aside .current {
        color: red;
        text-decoration-color: red;
    }

footer {
    grid-area: footer;
    display: flex;
    align-items: center;
}

    footer p {
        display: block;
        margin: 0 auto;
        color: white;
    }

table {
	border-collapse: collapse;
	width: auto;
}

table, th, td {
	border-bottom: 1px solid;
	text-align: center;
}

th, td {
    padding: 5px 20px;
}

table .assignment-name {
	text-align: left;
}

/*@media (prefers-color-scheme: dark) {
    body {
        background-color: black;
    }

    section {
        color: white;
    }
}*/

#login-form-container {
    height: 100vh;
    display: flex;
    align-items: center;
    justify-content: center;
}

#login-form {
    z-index: 1;
    text-align: center;
    display: block;
    padding: 20px;
    background-color: white;
    box-shadow: 3px 3px 30px black;
    max-width: 200px;
}

    #login-form h1 {
        text-align: center;
    }

    #login-form fieldset {
        border: none;
    }

    #login-form input {
        text-align: left;
        border: none;
        height: 30px;
        width: 100%;
        padding: 3px 10px;
        margin-top: 20px;
    }

    #login-form input[type=text], #login-form input[type=password] {
        border-bottom: 2px solid gray;
        width: calc(100% - 20px);
    }

    #login-form input[type=submit] {
        background-color: lightgrey;
        width: auto;
    }

    #easter-egg-wall {
        position: absolute;
        height: 100vh;
        width: 100vw;
        z-index: 0;
        background: rgb(2,0,36);
        background: linear-gradient(90deg, rgba(2,0,36,1) 0%, rgba(9,37,121,1) 82%, rgba(9,91,121,1) 100%); 
    }

.clearfix {
    clear: both;
}

.overdue {
    color: red;
}

.ok {
    color: green;
}

.overdueRow {
    background-color: lightgrey;
}

.todoRow {
    background-color: #e7ff96;
}

.doneRow {
    background-color: palegreen;
}

.archived {
    background-color: #e6e6e6;
}

.agreement {
    background-color: #96c5ff;
}

.lastminute {
    background-color: #f45a5a;
}

.agreement-text {
    color: #96c5ff;
    border-color: black;
    font-weight: bold;
}

.legend-wrapper {
    position: relative;
}

.legend {
    width: auto;
    padding: 10px;
    float: left;
}

.legend p {
    padding: 0 10px;
    margin: 3px 5px;
}

@media only screen and (max-width: 1000px) {
    body {
        grid-template-columns: 10px 15% 10px auto 10px;
    }

    header {
        padding: 10px 3%;
    }

    #header-right-flex {
        right: 3%;
    }
}

.loadOption {
    color: firebrick;
    text-decoration: underline;
    cursor: pointer;
}



/* This is copied from https://www.w3schools.com/css/css_tooltip.asp :) */

/* Tooltip container */
.tooltip {
  position: relative;
}

/* Tooltip text */
.tooltip .tooltip-text {
  visibility: hidden;
  width: 120px;
  background-color: black;
  color: #fff;
  text-align: center;
  padding: 5px 0;
  border-radius: 6px;
 
  /* Position the tooltip text */
  position: absolute;
  z-index: 1;
}

/* Show the tooltip text when you mouse over the tooltip container */
.tooltip:hover .tooltip-text {
  visibility: visible;
}

.task-instructions {
    background-color: rgba(0,0,255,0.1);
    margin: 5px;
    padding: 1px 10px;    
}

.task-instructions strong {
	color: red;
}


/* UPLOAD FORM */

#tryUploadForm {
    background-color: rgba(0,0,255,0.1);
    margin: 5px;
    padding: 10px; 
}

.formPart:first-of-type {
    margin-bottom: 10px;
}

.testPagePart {
    margin: 5px;
}

.CodeMirror {
    border: 1px solid rgba(0,0,255,0.1);
}

.comment-content-wrapper {
    margin: 5px;
}


/* xmas lights */
.lightrope {
  text-align: center;
  white-space: nowrap;
  overflow: hidden;
  position: absolute;
  z-index: 1;
  margin: -15px 0 0 0;
  padding: 0;
  pointer-events: none;
  width: 100%;
}
.lightrope li {
  position: relative;
  -webkit-animation-fill-mode: both;
          animation-fill-mode: both;
  -webkit-animation-iteration-count: infinite;
          animation-iteration-count: infinite;
  list-style: none;
  margin: 0;
  padding: 0;
  display: block;
  width: 12px;
  height: 28px;
  border-radius: 50%;
  margin: 20px;
  display: inline-block;
  background: #00f7a5;
  box-shadow: 0px 4.6666666667px 24px 3px #00f7a5;
  -webkit-animation-name: flash-1;
          animation-name: flash-1;
  -webkit-animation-duration: 2s;
          animation-duration: 2s;
}
.lightrope li:nth-child(2n+1) {
  background: aqua;
  box-shadow: 0px 4.6666666667px 24px 3px rgba(0, 255, 255, 0.5);
  -webkit-animation-name: flash-2;
          animation-name: flash-2;
  -webkit-animation-duration: 0.4s;
          animation-duration: 0.4s;
}
.lightrope li:nth-child(4n+2) {
  background: #f70094;
  box-shadow: 0px 4.6666666667px 24px 3px #f70094;
  -webkit-animation-name: flash-3;
          animation-name: flash-3;
  -webkit-animation-duration: 1.1s;
          animation-duration: 1.1s;
}
.lightrope li:nth-child(odd) {
  -webkit-animation-duration: 1.8s;
          animation-duration: 1.8s;
}
.lightrope li:nth-child(3n+1) {
  -webkit-animation-duration: 1.4s;
          animation-duration: 1.4s;
}
.lightrope li:before {
  content: "";
  position: absolute;
  background: #222;
  width: 10px;
  height: 9.3333333333px;
  border-radius: 3px;
  top: -4.6666666667px;
  left: 1px;
}
.lightrope li:after {
  content: "";
  top: -14px;
  left: 9px;
  position: absolute;
  width: 52px;
  height: 18.6666666667px;
  border-bottom: solid #222 2px;
  border-radius: 50%;
}
.lightrope li:last-child:after {
  content: none;
}
.lightrope li:first-child {
  margin-left: -40px;
}

@-webkit-keyframes flash-1 {
  0%, 100% {
    background: #00f7a5;
    box-shadow: 0px 4.6666666667px 24px 3px #00f7a5;
  }
  50% {
    background: rgba(0, 247, 165, 0.4);
    box-shadow: 0px 4.6666666667px 24px 3px rgba(0, 247, 165, 0.2);
  }
}

@keyframes flash-1 {
  0%, 100% {
    background: #00f7a5;
    box-shadow: 0px 4.6666666667px 24px 3px #00f7a5;
  }
  50% {
    background: rgba(0, 247, 165, 0.4);
    box-shadow: 0px 4.6666666667px 24px 3px rgba(0, 247, 165, 0.2);
  }
}
@-webkit-keyframes flash-2 {
  0%, 100% {
    background: aqua;
    box-shadow: 0px 4.6666666667px 24px 3px aqua;
  }
  50% {
    background: rgba(0, 255, 255, 0.4);
    box-shadow: 0px 4.6666666667px 24px 3px rgba(0, 255, 255, 0.2);
  }
}
@keyframes flash-2 {
  0%, 100% {
    background: aqua;
    box-shadow: 0px 4.6666666667px 24px 3px aqua;
  }
  50% {
    background: rgba(0, 255, 255, 0.4);
    box-shadow: 0px 4.6666666667px 24px 3px rgba(0, 255, 255, 0.2);
  }
}
@-webkit-keyframes flash-3 {
  0%, 100% {
    background: #f70094;
    box-shadow: 0px 4.6666666667px 24px 3px #f70094;
  }
  50% {
    background: rgba(247, 0, 148, 0.4);
    box-shadow: 0px 4.6666666667px 24px 3px rgba(247, 0, 148, 0.2);
  }
}
@keyframes flash-3 {
  0%, 100% {
    background: #f70094;
    box-shadow: 0px 4.6666666667px 24px 3px #f70094;
  }
  50% {
    background: rgba(247, 0, 148, 0.4);
    box-shadow: 0px 4.6666666667px 24px 3px rgba(247, 0, 148, 0.2);
  }
}